/* $Id: wmaction.h,v 1.4 2000/10/30 21:21:19 komatsu Exp $ */

#ifndef __WM_ACTION_H__
#define __WM_ACTION_H__

#include <glib.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

void wm_action_for_group(GtkWidget *widget, GdkEvent *event, gpointer data,
			 void (* func)(GtkWidget*, GdkEvent*, gpointer));

void wm_action_raise      (GtkWidget *widget, GdkEvent *event, gpointer data);
void wm_action_raise_group(GtkWidget *widget, GdkEvent *event, gpointer data);

void wm_action_lower      (GtkWidget *widget, GdkEvent *event, gpointer data);
void wm_action_lower_group(GtkWidget *widget, GdkEvent *event, gpointer data);

void wm_action_iconify    (GtkWidget *widget, GdkEvent *event, gpointer data);
void wm_action_iconify_group(GtkWidget *widget, GdkEvent *event,gpointer data);

void wm_action_deiconify(GtkWidget *widget, GdkEvent *event, gpointer data);
void wm_action_deiconify_group(GtkWidget *widget, GdkEvent *event, gpointer data);

void wm_action_move(GtkWidget *widget, GdkEventMotion *event, gpointer data);
void wm_action_move_group(GtkWidget *widget, GdkEvent *event, gpointer data);

void wm_action_resize(GtkWidget *widget, GdkEventMotion *event, gpointer data);
void wm_action_resize_group(GtkWidget *widget, GdkEvent *event, gpointer data);

void wm_action_resize_rx(GtkWidget *widget, GdkEventMotion *event,
			 gpointer data);
void wm_action_resize_rx_group(GtkWidget *widget, GdkEvent *event,
			       gpointer data);

void wm_action_resize_vertical(GtkWidget *widget, GdkEventMotion *event,
			       gpointer data);
void wm_action_resize_vertical_group(GtkWidget *widget, GdkEvent *event,
				     gpointer data);

void wm_action_resize_horizontal(GtkWidget *widget, GdkEventMotion *event,
				 gpointer data);
void wm_action_resize_horizontal_group(GtkWidget *widget, GdkEvent *event,
				       gpointer data);

void wm_action_close      (GtkWidget *widget, GdkEvent *event, gpointer data);
void wm_action_close_group(GtkWidget *widget, GdkEvent *event, gpointer data);

void wm_action_destroy    (GtkWidget *widget, GdkEvent *event, gpointer data);
void wm_action_destroy_group(GtkWidget *widget, GdkEvent *event,gpointer data);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __WM_ACTION_H__ */
